﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;

namespace Ispit
{
    class Kontrolor : Atomic
    {
        List<PortValue> buffer;

        public InputPort lopticaIP;
        public OutputPort kolizijaOP;
        public InputPort povrsinaIP;

        List<RavnaPovrsina> povrsine;

        public Kontrolor(string name, TimeUnit tu) : base(name, tu)
        {
            lopticaIP = AddIP("lopticaIP");
            povrsinaIP = AddIP("povrsinaIP");
            kolizijaOP = AddOP("kolizijaOP");

            povrsine = new List<RavnaPovrsina>();
            buffer = new List<PortValue>();
        }

        public override bool delta_x(PortValue x)
        {
            if ( x.port == lopticaIP )
            {
                LoptaInfo l = x.value as LoptaInfo;

                foreach (var p in povrsine)
                {
                    if ( p.pos.z == 0 ) // da li je pod
                    {
                        if ( l.pos.x > p.pos.x - p.a && l.pos.x < p.pos.x + p.a &&
                             l.pos.y > p.pos.y - p.b && l.pos.y < p.pos.y + p.b &&
                             l.pos.z >=0 && l.pos.z + l.pos.z * l.v.z * l.e < 0 )
                        {
                            buffer.Add(new PortValue(kolizijaOP, l));
                        }
                    }
                    else // da li je tabla
                    {
                        if (l.pos.z > p.pos.z - p.b && l.pos.z < p.pos.z + p.b &&
                             l.pos.y > p.pos.y - p.a && l.pos.y < p.pos.y + p.a &&
                             l.pos.x >= 0 && l.pos.x + l.pos.x * l.v.x * l.e < 0)
                        {
                            buffer.Add(new PortValue(kolizijaOP, l));
                        }
                    }
                }

                return true;
            }   
            else if ( x.port == povrsinaIP )
            {
                RavnaPovrsina r = x.value as RavnaPovrsina;

                povrsine.Add(r);

                return false;
            }

            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            if (buffer.Count > 0)
            {
                y = buffer[0];
                buffer.RemoveAt(0);
                return;
            }
        }

        public override void init()
        {
        }

        public override double tau()
        {
            if (buffer.Count > 0) return 0;
            return double.MaxValue;
        }
    }
}
