﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;

namespace Ispit
{
    class Sistem : Coupled
    {
        public InputPort lvIP, lpIP;

        public Sistem(string name) : base(name)
        {
            Lopta l = new Lopta("lopta1", TimeUnit.Sec, 1, new Vector(0, 0, 100), new Vector(1, 1, 19), 10);
            Stampac s = new Stampac("stampac1", TimeUnit.Sec);
            Povrsina pod = new Povrsina("pod", TimeUnit.Sec,new Vector(0,0,0), 100, 100);
            Povrsina tabla = new Povrsina("tabla", TimeUnit.Sec, new Vector(10, 10, 10), 10, 10);
            Kontrolor k = new Kontrolor("kontrolor", TimeUnit.Sec);

            AddModel(l);
            AddModel(s);
            lvIP = AddIP("lvIP");
            lpIP = AddIP("lpIP");

            AddCP(l.OP, s.IP);
            AddCP(l.OP, k.lopticaIP);

            AddCP(lvIP, l.lvIP);
            AddCP(lpIP, l.lpIP);

            AddCP(pod.loptaOP, l.kolizijaIP);
            AddCP(tabla.loptaOP, l.kolizijaIP);

            AddCP(pod.povrsinaOP, k.povrsinaIP);
            AddCP(tabla.povrsinaOP, k.povrsinaIP);

            AddCP(pod.zvukOP, s.zvukPodIP);
            AddCP(tabla.zvukOP, s.zvukTablaIP);

            AddCP(k.kolizijaOP, tabla.kolizijaIP);
            AddCP(k.kolizijaOP, pod.kolizijaIP);
        }
    }
}
