﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;
using System.IO;

namespace Ispit
{
    class Stampac : Atomic
    {
        StreamWriter sw;
        public InputPort IP;
        public InputPort zvukPodIP;
        public InputPort zvukTablaIP;

        double x, y, z, tabla, pod;

        public Stampac(string name, TimeUnit tu) : base(name, tu)
        {
            IP = AddIP("IP");
            zvukPodIP = AddIP("zvukPodIP");
            zvukTablaIP = AddIP("zvukTablaIP");
        }

        public override bool delta_x(PortValue x)
        {
            if (x.port == IP)
            {
                Vector v = x.value as Vector;
                this.x = v.x;
                this.y = v.y;
                this.z = v.z;
            }
            else if (x.port == zvukPodIP)
            {
                double v = (double)x.value;
                this.pod = v;
            }
            else if (x.port == zvukTablaIP)
            {
                double v = (double)x.value;
                this.tabla = v;
            }
            else return false;

            sw.WriteLine(this.x + " , " + y + " , " + z + " , " + tabla + " , " + pod);
            sw.Flush();
            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            throw new NotImplementedException();
        }

        public override void init()
        {
            if (sw != null) sw.Close();
            sw = new StreamWriter("out.csv");
            x = y = z = tabla = pod = 0;
        }

        public override double tau()
        {
            return double.MaxValue;
        }
    }
}
