﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DEVSsharp;
using System.IO;

namespace Automobil
{
    public class GPS : Atomic
    {
        public string fileName;

        StreamWriter sw;

        public InputPort inputS;
        public InputPort inputV;

        double S;
        double V;

        public GPS(string name, TimeUnit tu, string fileName) 
            : base(name, tu)
        {
            this.fileName = fileName;

            inputS = AddIP("inputS");
            inputV = AddIP("inputV");
        }

        public override void init()
        {
            if (sw != null)
                sw.Close();

            sw = new StreamWriter(fileName);

            S = 0;
            V = 5;
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port == inputS)
            {
                S = (double)x.value;
            }
            else if (x.port == inputV)
            {
                V = (double)x.value;
            }

            sw.WriteLine(TimeCurrent + "," + S + "," + V);
            sw.Flush();

            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            throw new NotImplementedException();
        }

        public override double tau()
        {
            return double.MaxValue;
        }
    }
}
