﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DEVSsharp;

namespace rad
{
    public class Point
    {
      public  double x, y,z;

        public Point pomnozi(double t)
        {

            Point p = new rad.Point();
            p.x = this.x * t;
            p.y = this.y *= t;
            p.z =  this.z *= t;
            return p;
        }
        public Point saberi(Point p)
        {
            Point pp = new rad.Point();
            pp.x = p.x + this.x;
            pp.y = p.y + this.y;
            pp.z = p.z + this.z;
            return pp;
        }
    }
    
    public class Lopta : Atomic
    {
        public Point g;
        public Point v;
        public Point pozicija;
        public double eps;

        public InputPort inputV;
        public InputPort inputPozicija;

        public OutputPort outputPoz;
        

        List<PortValue> msgBuf;

        public Lopta(string name, TimeUnit tu, double eps, Point V0, Point pozicija) 
            : base(name, tu)
        {
            this.eps = eps;
            this.v = V0;
            g.x = 0;
            g.y = -9.81;
            g.z = 0;
            this.pozicija = pozicija;

            inputV = AddIP("inputV");
            inputPozicija = AddIP("inputPozicija");

            outputPoz = AddOP("outputPoz");
            
        }

        public override void init()
        {
            
            msgBuf = new List<PortValue>();

            msgBuf.Add(new PortValue(outputPoz, this.pozicija));
            
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port == inputV)
            {
                pozicija = IzracunajPoziciju(TimeElapsed);

                this.v = (Point)x.value;

                msgBuf.Add(new PortValue(outputPoz, pozicija));
                

                return true;
            }

            if (x.port == inputPozicija)
            {
                pozicija = (Point)x.value;

                this.v.x = 0;
                this.v.y = 0;
                this.v.z = 0;

                msgBuf.Add(new PortValue(outputPoz, pozicija));


                return true;
            }

            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            if (msgBuf.Count() > 0)
            {
                y = msgBuf[0];
                msgBuf.RemoveAt(0);

                return;
            }

            pozicija = IzracunajPoziciju(TimeElapsed);

            msgBuf.Add(new PortValue(outputPoz, pozicija));
        }

        private Point IzracunajPoziciju(double dt)
        {



            Point brzinaVreme = this.v.pomnozi(dt);
            Point ubrzanjeVremeKvadrat = this.g.pomnozi(dt * dt / 2);
            Point predjeniPut = brzinaVreme.saberi(ubrzanjeVremeKvadrat);

            pozicija = pozicija.saberi(predjeniPut);
            Point ubrzanjeVreme = this.g.pomnozi(dt);
            this.v = this.v.saberi(ubrzanjeVreme);
            return pozicija;
        }

        public override double tau()
        {
            if (msgBuf.Count() > 0)
                return 0.0;

            return eps / (Math.Abs(this.v.x) + Math.Abs(this.v.y) + Math.Abs(this.v.z));
        }

        public override string Get_s()
        {
            return "X: " + pozicija.x +  "Y: "+pozicija.y  +"Z: " +pozicija.z+ "| V: " + v;
        }
    }
}
