﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DEVSsharp;

namespace rad
{
    class Povrsina : Atomic
    {
        public double a, b;
        public double koeficijentProprocionalnosti;
        public double jacinaZvuka;
        public Point pozicija;
        public double eps;

        public InputPort inputV;
        public InputPort inputPozicija;

        public OutputPort outputPoz;


        List<PortValue> msgBuf;

        public Povrsina(string name, TimeUnit tu, double eps, Point V0, Point pozicija) 
            : base(name, tu)
        {
            this.eps = eps;
            this.v = V0;
            g.x = 0;
            g.y = -9.81;
            g.z = 0;
            this.pozicija = pozicija;

            inputV = AddIP("inputV");
            inputPozicija = AddIP("inputPozicija");

            outputPoz = AddOP("outputPoz");

        }

        public override void init()
        {

            msgBuf = new List<PortValue>();

            msgBuf.Add(new PortValue(outputPoz, this.pozicija));

        }

        public override bool delta_x(PortValue x)
        {
            if (x.port == inputV)
            {
                pozicija = IzracunajPoziciju(TimeElapsed);

                this.v = (Point)x.value;

                msgBuf.Add(new PortValue(outputPoz, pozicija));


                return true;
            }

            if (x.port == inputPozicija)
            {
                pozicija = (Point)x.value;

                this.v.x = 0;
                this.v.y = 0;
                this.v.z = 0;

                msgBuf.Add(new PortValue(outputPoz, pozicija));


                return true;
            }

            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            if (msgBuf.Count() > 0)
            {
                y = msgBuf[0];
                msgBuf.RemoveAt(0);

                return;
            }

            pozicija = IzracunajPoziciju(TimeElapsed);

            msgBuf.Add(new PortValue(outputPoz, pozicija));
        }

        private Point IzracunajPoziciju(double dt)
        {




            this.pozicija.x += this.v.x * dt;
            this.pozicija.y += this.v.y * dt;
            this.pozicija.z += this.v.z * dt;

            this.v.x = this.v.x + dt * g.x;
            this.v.y = this.v.y + dt * g.y;
            this.v.z = this.v.z + dt * g.z;
            return pozicija;
        }

        public override double tau()
        {
            if (msgBuf.Count() > 0)
                return 0.0;

            return eps / (Math.Abs(this.v.x) + Math.Abs(this.v.y) + Math.Abs(this.v.z));
        }

        public override string Get_s()
        {
            return "X: " + pozicija.x + "Y: " + pozicija.y + "Z: " + pozicija.z + "| V: " + v;
        }
    }
}

