﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DEVSsharp;

namespace Automobil
{
    public class Sistem : Coupled
    {
        public InputPort inputV;

        public Sistem(string name) 
            : base(name)
        {
            Vozilo v = new Vozilo("V1", TimeUnit.Sec, 2);
            GPS gps = new GPS("GPS", TimeUnit.Sec, "gps.csv");

            this.AddModel(v);
            this.AddModel(gps);
            
            this.AddCP(v.outputS, gps.inputS);
            this.AddCP(v.outputV, gps.inputV);
            
            inputV = AddIP("inputV");

            this.AddCP(inputV, v.inputV);

            this.PrintCouplings();
        }
    }
}
