﻿using DEVSsharp;
using Stefan_Stamenkovic_91_2014.Utils;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stefan_Stamenkovic_91_2014.Models
{
    class Printer : Atomic
    {
        private StreamWriter sw;

        private Vector position;

        public InputPort InputPosition { get; set; }
        public InputPort InputTable { get; set; }
        public InputPort InputFloor { get; set; }
        private double tableSound = 0;
        private double floorSound = 0;

        public Printer(string name, TimeUnit tu) : base(name, tu)
        {
            InputPosition = AddIP("printerInputPosition");
            InputTable = AddIP("printerInputTable");
            InputFloor = AddIP("printerInputFloor");
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port==InputPosition)
            {
                position = x.value as Vector;
            }
            else if(x.port == InputTable)
            {
                tableSound = (double)x.value;
            }
            else if(x.port==InputFloor)
            {
                floorSound = (double)x.value;
            }

            sw.WriteLine(String.Format("{0},{1},{2},{3},{4},{5}", TimeCurrent, position.X, position.Y, position.Z, tableSound, floorSound));
            sw.Flush();

            return true;
        }

        public override void delta_y(ref PortValue y)
        {
            throw new NotImplementedException();
        }

        public override void init()
        {
            if(File.Exists("./output.csv"))
            {
                File.Delete("./output.csv");
            }

            sw = new StreamWriter(File.Open("./output.csv", FileMode.OpenOrCreate));

            sw.WriteLine("Vreme, X, Y, Z, ZvukTabla, ZvukPod");
            sw.Flush();
        }

        public override double tau()
        {
            return Double.MaxValue;
        }
    }
}
