﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stefan_Stamenkovic_91_2014.Utils
{
    class Vector
    {
        public double X { get; set; }
        public double Y { get; set; }
        public double Z { get; set; }

        public Vector(double x, double y, double z)
        {
            X = x;
            Y = y;
            Z = z;
        }

        public Vector WithIntensity(double speed, double zSpeed)
        {
            double intensity = speed / Intensity();
            double zIntensity = zSpeed / Intensity();

            return new Vector(X * intensity, Y * intensity, Z * zIntensity);
        }

        public Vector WithIntensity(double speed)
        {
            double intensity = speed / Intensity();

            return new Vector(X * intensity, Y * intensity, Z * intensity);
        }

        public double Intensity()
        {
            return Math.Sqrt(X * X + Y * Y + Z * Z);
        }

        public Vector Add(Vector v2)
        {
            return new Vector(X + v2.X, Y + v2.Y, Z + v2.Z);
        }

        public Vector Clone()
        {
            return new Vector(X, Y, Z);
        }

        public static Vector Parse(string[] args)
        {
            return new Vector(Double.Parse(args[0]), Double.Parse(args[1]), Double.Parse(args[2]));
        }

        public Vector MakeSuplement(Vector myVector)
        {
            double t = X * myVector.X + Y * myVector. Y + Z * myVector.Z;

            return new Vector(X - 2 * t * myVector.X, Y - 2 * t * myVector.Y, Z - 2 * t * myVector.Z);
        }
    }
}
