﻿using DEVSsharp;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Devs
{
    public class Kontroler : Atomic
    {

        public InputPort inputPod;
        public OutputPort outputPod;
        public InputPort inputTabla;
        public OutputPort outputTabla;
        public OutputPort inputLopta;
        public InputPort outputLopta;
        public List<PortValue> buf;

        Vektor pod;
        Vektor lopta;
        Vektor tabla;

        public Kontroler(string name, TimeUnit tu) : base(name, tu)
        {
          

        }

        public override void init()
        {
             buf = new List<PortValue>();
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port == inputPod)
            {
                pod = (Vektor)x.value;
              
            }
            else if(x.port == inputTabla)
            {
                tabla = (Vektor)x.value;
            }
            else if(x.port == inputLopta)
            {
                lopta = (Vektor)x.value;
                return true;
            }
            return false;
            
        }

        public override void delta_y(ref PortValue y)
        {
            if (buf.Count() > 0)
            {
                y = buf[0];
                buf.RemoveAt(0);
                return;
            }
            if (lopta.x < pod.x || lopta.y < pod.y)
                buf.Add(new PortValue(outputPod, "udario"));
            
        }

      
        public override double tau()
        {
            if (buf.Count() > 0)
                return 0.0;
            return double.MaxValue;
        }
    }
}
