﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;

namespace Devs
{
    public class Lopta : Atomic
    {
        public Vektor brzina;
        public Vektor pozicija;
        public Vektor pomeraj;
        public double g;
        public double eps;
        public double r;

        public InputPort inputK;
        public OutputPort outputL;
        public List<PortValue> buf;

        public Lopta(string name, TimeUnit tu) : base(name, tu)
        {
            outputL = AddOP("outputL");
            inputK = AddIP("inputK");
        }

        public override void init()
        {
            r = 2.0;
            brzina = new Vektor(-2.0, -1.0, 0.0);
            pozicija = new Vektor(5.0,5.0, 0.0);
            eps = 0.1;      
            g = 9.81;
            buf = new List<PortValue>();    
            
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port == inputK)
            {

            }
        }

        public override void delta_y(ref PortValue y)
        {
            if(buf.Count() > 0)
            {      
                y = buf[0];
                buf.RemoveAt(0);
                return;
            }
            Vektor norm_vektor = Vektor.norm(brzina);
            Vektor pomeraj = Vektor.pomnozi(brzina, eps);
            pozicija.saberi(pomeraj);
            buf.Add(new PortValue(outputL, pozicija));        
        }

       
        public override double tau()
        {
            if (buf.Count() > 0)
                return 0;

            double speed = brzina.getIntensity();
            double t = (-speed + Math.Sqrt(speed * speed + 4 * g / 2)) / 2;
            return t;                                                                                                                                
        }
    }
}
