﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;

namespace Devs
{
    public class Povrsina : Atomic
    {
        public double a, b;
        public Vektor centar;
        public Vektor A;
        public Vektor B;
        public InputPort inputKontroler;
        public OutputPort outputKontroler;
        public List<PortValue> buf;
        string vrsta;

        public Povrsina(string name, TimeUnit tu,string vrsta) : base(name, tu)
        {
            inputKontroler = AddIP("inputK");
            outputKontroler = AddOP("outputK");
            this.vrsta = vrsta;
     
        }

        public override void init()
        {
            a = 2;
            b = 2;
            if (vrsta.Equals("pod"))
            {
                centar = new Vektor(5.0, 0.0, 5.0);
                A = new Vektor(centar.x - a, centar.y, centar.z - b);
                B = new Vektor(centar.x + a, centar.y, centar.z + b);
            }
            else
            {
                centar = new Vektor(5.0, 0.0, 5.0);
                A = new Vektor(centar.x, centar.y - a, centar.z - b);
                B = new Vektor(centar.x, centar.y - a, centar.z + b);
            }
            buf.Add(new PortValue(outputKontroler, A));
            buf.Add(new PortValue(outputKontroler, B));
        }

        public override bool delta_x(PortValue x)
        {
           
        }

        public override void delta_y(ref PortValue y)
        {
            if (buf.Count() > 0)
            {
                y = buf[0];
                buf.RemoveAt(0);
                return;
            }
        }

        public override double tau()
        {
            if (buf.Count() > 0)
                return 0.0;
            return double.MaxValue; 
        }
    }
}
