﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;

namespace LazarVasovic642014
{
    class Igra : Coupled
    {
        public Igra(string name) : base(name)
        {
            Stampac s = new Stampac("stampac", TimeUnit.Sec);
            Lopta l = new Lopta("lopta", TimeUnit.Sec);
            RavnaPovrsina pod = new RavnaPovrsina("pod", TimeUnit.Sec, double.MaxValue, double.MaxValue, new Vector3D(0, 0, 1), new Vector3D(0, 0, 0), "XY");
            RavnaPovrsina tabla = new RavnaPovrsina("tabla", TimeUnit.Sec, 1.5, 0.9, new Vector3D(1, 0, 0), new Vector3D(0, 1, 3), "YZ");
            Kontroler k = new Kontroler("kontroler", TimeUnit.Sec);
            this.AddModel(k);
            this.AddModel(pod);
            this.AddModel(tabla);
            this.AddModel(s);
            this.AddModel(l);
            this.AddCP(l.outPozicija, s.inputPozicija);
            this.AddCP(l.outKontroler, k.inputLopta);
            this.AddCP(pod.outKontrolerTabla, k.inputTabla);
            this.AddCP(tabla.outKontrolerTabla, k.inputTabla);
            this.AddCP(pod.outOdbitakLoptice, l.inputNovaBrzina);
            this.AddCP(tabla.outOdbitakLoptice, l.inputNovaBrzina);
            this.AddCP(k.outTablaXY, pod.inputUdarac);
            this.AddCP(k.outTablaYZ, tabla.inputUdarac);
            this.AddCP(pod.outZvuk,s.inputZvukPod);
            this.AddCP(tabla.outZvuk,s.inputZvukTabla);
        }
    }
}
