﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;

namespace LazarVasovic642014
{
    class Kontroler : Atomic
    {
        public InputPort inputTabla;
        public InputPort inputLopta;
        public OutputPort outTablaXY;
        public OutputPort outTablaYZ;
        List<RavnaPovrsina> litaTabli;
        Lopta lopta;
        List<PortValue> bafer;

        public Kontroler(string name, TimeUnit tu) : base(name, tu)
        {
            inputLopta = AddIP("inputLopta");
            inputTabla = AddIP("inputTabla");
            outTablaXY = AddOP("outTablaXY");
            outTablaYZ = AddOP("outTablaYZ");
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port==inputTabla)
            {
                this.litaTabli.Add((RavnaPovrsina)x.value);
            }else if(x.port==inputLopta)
            {
                lopta = (Lopta)x.value;
                string ravan = DaLiDolaziDoKolizije();
                if(ravan=="XY")
                {
                    bafer.Add(new PortValue(outTablaXY, "kolizija"));
                }else if(ravan=="YZ")
                {
                    bafer.Add(new PortValue(outTablaYZ, "kolizija"));
                }

                return true;
            }

            return false;
        }

        public string DaLiDolaziDoKolizije()
        {
            double t = lopta.epsK / lopta.brzina.Intensity();

            Vector3D novaPozicija = lopta.pozicija + lopta.brzina * t;

            for (int i = 0; i < this.litaTabli.Count; i++)
            {
                if (litaTabli[i].paralelnost == "XY" && this.lopta.pozicija.z > 0 && novaPozicija.z < 0)
                    return "XY";
                else if (litaTabli[i].paralelnost == "YZ" && ((this.lopta.pozicija.x > 0 && novaPozicija.x < 0) || (this.lopta.pozicija.x < 0 && novaPozicija.x > 0)))
                {
                    if(this.lopta.pozicija.y>=(this.litaTabli[i].centar.y - this.litaTabli[i].a/2) && this.lopta.pozicija.y <= (this.litaTabli[i].centar.y + this.litaTabli[i].a / 2) &&
                        this.lopta.pozicija.z >= (this.litaTabli[i].centar.z - this.litaTabli[i].b / 2) && this.lopta.pozicija.z <= (this.litaTabli[i].centar.z + this.litaTabli[i].b / 2))
                    return "YZ";
                }
                    
            }

            return "NE";
        }

        public override void delta_y(ref PortValue y)
        {
            if(bafer.Count>0)
            {
                y = bafer[0];
                bafer.RemoveAt(0);
                return;
            }
        }

        public override void init()
        {
            bafer = new List<PortValue>();
            litaTabli = new List<RavnaPovrsina>();
        }

        public override double tau()
        {
            if (bafer.Count > 0)
                return 0;

            return double.MaxValue;
        }
    }
}
