﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;
using System.IO;

namespace LazarVasovic642014
{
    class Stampac : Atomic
    {
        string fileName = "izlaz.csv";
        StreamWriter sw;
        public InputPort inputPozicija;
        public InputPort inputZvukTabla;
        public InputPort inputZvukPod;
        Vector3D poz = new Vector3D(0,0,0);
        double dbTabla = 0;
        double dbPod = 0;

        public Stampac(string name, TimeUnit tu) : base(name, tu)
        {
            inputPozicija = AddIP("inputPozicija");
            inputZvukTabla = AddIP("inputZvukTabla");
            inputZvukPod = AddIP("inputZvukPod");
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port==inputPozicija)
            {
                poz = (Vector3D)x.value;
                
            }
            else if(x.port==inputZvukTabla)
            {
                dbTabla = (double)x.value;
            }else if(x.port==inputZvukPod)
            {
                dbPod = (double)x.value;
            }

            sw.WriteLine(TimeCurrent + "," + poz.x + "," + poz.y + "," + poz.z + "," + dbTabla + "," + dbPod);
            sw.Flush();

            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            throw new NotImplementedException();
        }

        public override void init()
        {
            sw = new StreamWriter(fileName);
            sw.WriteLine("Vreme,PozicijaX,PozicijaY,PozicijaZ,ZvukTabla,ZvukPod");
            sw.Flush();
        }

        public override double tau()
        {
            return double.MaxValue;
        }
    }
}
