﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LazarVasovic642014
{
    class Vector3D
    {
        public double x { get; set; }
        public double y { get; set; }
        public double z { get; set; }

        public Vector3D(double x, double y, double z)
        {
            this.x = x;
            this.y = y;
            this.z = z;
        }

        public static Vector3D operator +(Vector3D v1, Vector3D v2)
        {
            return new Vector3D(v1.x + v2.x, v1.y + v2.y, v1.z + v2.z);
        }

        public static Vector3D operator -(Vector3D v1, Vector3D v2)
        {
            return new Vector3D(v1.x - v2.x, v1.y - v2.y, v1.z - v2.z);
        }

        public static Vector3D operator *(Vector3D v1, double a)
        {
            return new Vector3D(v1.x * a, v1.y * a, v1.z * a);
        }

        public double Intensity()
        {
            return Math.Sqrt(x * x + y * y + z * z);
        }

        public double DotProduct(Vector3D v)
        {
            return x * v.x + y * v.y + z * v.z;
        }

        public static Vector3D CrossProduct(Vector3D u, Vector3D v)
        {
            Vector3D x = new Vector3D(1, 0, 0);
            Vector3D y = new Vector3D(0, 1, 0);
            Vector3D z = new Vector3D(0, 0, 1);

            Vector3D rez = new Vector3D(u.y * v.z - u.z * v.y, u.z * v.x - u.x * v.z, u.x * v.y - u.y * v.x);
            return rez;
        }

        public override string ToString()
        {
            return "(" + x + ", " + y + ", " + z + ")";
        }
    }
}
